//
// NOSOUND driver for sega mega drive
// Copyright(c) 2023 Emmanuel Rousseau;
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files(the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all; copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include "m_base.h"
#include "dev/m_devs.h"
#include "nosound.h"
#include "resources.h"
#include "res_nosound_index.h"  // <- this is generated by the python tools

static nosound_s* nos = NULL;
static bool paused    = FALSE;

void joy_handler(u16 joy, u16 changed, u16 state) {
    if (state & BUTTON_A && changed & BUTTON_A) {
        NO_Play(nos);
        paused = FALSE;
    }
    if (state & BUTTON_B && changed & BUTTON_B) {
        // NO_TestCommand(nos);
        if (!paused) {
            NO_Stop(nos);
            paused = TRUE;
        } else {
            NO_Resume(nos);
            paused = FALSE;
        }
    }

    if (state & BUTTON_X && changed & BUTTON_X) {
        NO_QueueSfx(nos, &nos_sfx_entries[2]);
    }

    if (state & BUTTON_Y && changed & BUTTON_Y) {
        NO_QueueSfx(nos, &nos_sfx_entries[1]);
    }

    if (state & BUTTON_C && changed & BUTTON_C) {
        NO_SetClockDivider(nos, 5, 1);
    }
}

int main() {
    u16 driver_size       = sizeof nosound_z80;
    const u8* driver_data = nosound_z80;

    nos = NO_NewDriver(driver_data, driver_size);
    NO_LoadSong(nos, nos_mod_entries[1].data);

    SYS_doVBlankProcess();
    VDP_drawText("NOSOUND driver for Mega Drive (c)", 1, 24);
    VDP_drawText("build " NOSOUND_BUILD, 1, 25);

    JOY_setSupport(PORT_1, JOY_SUPPORT_6BTN);
    JOY_setEventHandler(joy_handler);

    while (1) {
        SYS_doVBlankProcess();
        NO_UpdateAudio(nos);
    }
    return 0;
}
